// (C) 2017-2020 by folkert van heusden, released under AGPL v3.0
#include <frei0r.h>
#include <string>

#include "filter_plugin.h"

typedef void (*my_f0r_update)(f0r_instance_t instance, double time, const uint32_t* inframe, uint32_t* outframe);

class filter_plugin_frei0r : public filter_plugin
{
private:
	const std::string filter_filename, pars;
	my_f0r_update my_f0r_update_i{ nullptr };
	f0r_instance_t f_inst{ nullptr };
	int color_model{ -1 };
	f0r_plugin_info_t fpi{ 0 };

public:
	filter_plugin_frei0r(const std::string & filter_filename, const std::string & pars);
	~filter_plugin_frei0r();

	bool uses_in_out() const override { return true; }
	void apply_io(instance_t *const i, interface *const specific_int, const uint64_t ts, const int w, const int h, const uint8_t *const prev, const uint8_t *const in, uint8_t *const out) override;
};
